lnmp环境 编译安装php swoole扩展

        1、swoole是什么?

        Swoole:面向生产环境的 PHP 异步网络通信引擎

        官网:https://www.swoole.com/ 

        文档:https://wiki.swoole.com/ 


        2、为什么要使用 Swoole?

        常驻内存,避免重复加载带来的性能损耗,提升海量性能

        协程异步,提高对 I/O 密集型场景并发处理能力(如:微信开发、支付、登录等)

        方便地开发 Http、WebSocket、TCP、UDP 等应用,可以与硬件通信

        PHP 高性能微服务架构成为现实

        常驻内存:

                目前传统 PHP框架,在处理每个请求之前,都要做一遍加载框架文件、配置的操作。这可能已经成为性能问题的一大原因,而使用 Swoole 则没有这个问题,一次加载多次使用。

        协程:

                如下图所示,这是同一个线程处理并发请求的场景,比如你某个接口中需要调用其它 api 接口或读写大文件,传统同步阻塞和协程异步的优势就体现了出来。

        冷暖自知一抹茶ck

                说到协程,就得先简单说说进程和线程,众所周知进程是很占用资源的,为了处理请求大量创建进程肯定是得不偿失的。而多线程应用就比较多了,在 CPU 层面有几个核心就会执行几个任务,线程一旦创建的多了,就会有线程调度的损耗。

                协程是在单线程基础上实现的,它可以最大限度利用 CPU 资源,而不会在等待 I/O 时白白浪费。当然,协程数越多占用的内存也就越多,不过这个是可以接受的,相比进程和线程,占用的资源是相对较少的。

                使用协程时,遇到读写文件、请求接口等场景,会自动挂起协程,把 CPU 让给其它协程执行任务,这样可以提升单线程的 CPU 资源利用率,减少浪费,从而提高性能。

                协程方式执行并不是顺序的,性能更高,在sleep时会把当前线程的任务执行权交给其他协程。

        3、swoole可以用来做什么?

        使 PHP 开发人员可以编写高性能的异步并发 TCP、UDP、Unix Socket、HTTP,WebSocket 服务。Swoole 可以广泛应用于互联网、移动通信、企业软件、云计算、网络游戏、物联网(IOT)、车联网、智能家居等领域。 使用 PHP + Swoole 作为网络通信框架,可以使企业 IT 研发团队的效率大大提升,更加专注于开发创新产品。        


        4、swoole具体的特性

        PHP的异步、并行、高性能网络通信引擎,使用纯C语言编写,提供了PHP语言的异步多线程服务器,异步TCP/UDP网络客户端,异步MySQL,异步Redis,数据库连接池,AsyncTask,消息队列,毫秒定时器,异步文件读写,异步DNS查询。 Swoole内置了Http/WebSocket服务器端/客户端、Http2.0服务器端。

        除了异步 IO 的支持之外,Swoole 为 PHP 多进程的模式设计了多个并发数据结构和IPC通信机制,可以大大简化多进程并发编程的工作。其中包括了并发原子计数器,并发 HashTable,Channel,Lock,进程间通信IPC等丰富的功能特性。

        Swoole2.0 支持了类似 Go 语言的协程,可以使用完全同步的代码实现异步程序。PHP 代码无需额外增加任何关键词,底层自动进行协程调度,实现异步。

        

        5、swoole的扩展安装及使用

        查看官方文档后,我们发现,swoole已经作为php的一个扩展存在,意味着我们还得去安装它。是不是直接去下载so文件然后在php.ini中加入extension=swoole.so就可以了呢?还不是,我们先去看看Swoole扩展的依赖,这也是我们使用任何语言的任何外部包,外部模块,外部扩展最先要了解的问题。

        a)、环境依赖:

                1)、仅支持 Linux,FreeBSD,MacOS,3类操作系统

                2)、Linux 内核版本 2.3.32 以上

                3)、PHP-5.3.10 以上版本,包括PHP7

                4)、gcc4.4 以上版本或者clang

                5)、cmake2.4+,编译为 libswoole.so 作为 C/C++ 库时需要使用 cmake

                建议使用 Ubuntu14、CentOS7 或更高版本的操作系统

        b)、PHP版本依赖:

                1)、Swoole-1.x需要 PHP-5.3.10 或更高版本

                2)、Swoole-2.x需要 PHP-7.0.0 或更高版本

                3)、不依赖 PHP 的 stream、sockets、pcntl、posix、sysvmsg 等扩展。PHP 只需安装最基本的扩展即可

        

        意味着我们Windows下是无法使用这个扩展了(其实可以借助cygwin在win下使用swoole,但是考虑到我们使用swoole扩展就是为了性能,也为了熟悉以后的生产环节部署做准备,强烈推荐在linux下开发),那么我们把开发环境转移到Linux下进行吧。

        第一步:来搭建属于自己的环境吧~    少不了的、万能的虚拟机。

        当前环境:

        CentOS: 7.4.1708

        Nginx:1.10.2

        PHP :7.2.1

        MariaDB:10.2.11


        第二步:Linux下的编译安装

        swoole官网下载:http://pecl.php.net/package/swoole

[root@bogon src]# wget -O swoole-1.9.23.tgz  http://pecl.php.net/get/swoole-1.9.23.tgz
[root@bogon src]# tar -zxvf swoole-1.9.23.tgz
[root@bogon src]# cd swoole-1.9.23/
[root@bogon swoole-1.9.23]# /usr/local/php7/bin/phpize
Configuring for:
PHP Api Version:         20160303
Zend Module Api No:      20160303
Zend Extension Api No:   320160303

在这里附上http://www.cnblogs.com/hubing/p/4941692.html对phpize的解释 已经很明了了)
phpize的作用可以这样理解:
    侦测环境(phpize工具是在php安装目录下,基于这点phpize对应了当时的php环境,所以是要根据该php的配置情况生成对应的configure
文件),建立一个configure文件。必须在一个目录下去运行phpize。那么phpize就知道你的的环境是哪个目录,并且configure文件建立在
该目录下。

[root@bogon swoole-1.9.23]# ./configure --with-php-config=/usr/local/php7/bin/php-config
[root@bogon swoole-1.9.23]# make
[root@bogon swoole-1.9.23]# make test
[root@bogon swoole-1.9.23]# make install

编辑 php.ini文件:添加 : extension=redis.so
[root@bogon swoole-1.9.23]# vim /etc/php.ini

[swoole]
extension=swoole.so


重新启动php.ini

[root@localhost swoole-1.9.23]# systemctl restart  php-fpm.service


查看扩展是否已经添加

[root@localhost swoole-1.9.23]# php -m    或者phpinfo(),即可看到下图所示

冷暖自知一抹茶ck





冷暖自知一抹茶ck
请先登录后发表评论
  • 最新评论
  • 总共0条评论